<?php

/***************************************************************
 * Logimetrix Techsolutions Pvt. Ltd.
 * File Name   : ProductController.php
 * File Description  : ProductController
 * Created By : Puneet Mishra
 * Created Date: 25 Nov 2016
 ***************************************************************/

class ExpenseController extends Zend_Controller_Action{
  var $dbAdapter;
  var $db;
  public function init(){
   /* Initialize action controller here */
   $bootstrap = $this->getInvokeArg('bootstrap');
   $aConfig = $bootstrap->getOptions();
   $this->db = Zend_Db_Table::getDefaultAdapter();
   $auth = Zend_Auth::getInstance();
   $authStorage = $auth->getStorage();
   $this->WebLoginID = $authStorage->read()->WebLoginID;
   $users = new Application_Model_Users();
   $logout_details = $users->getUserLoginDetailByWebLoginCode($this->WebLoginID);
   $this->Role                    = $authStorage->read()->Role;
   $this->id                      = $authStorage->read()->id;
   $this->parent_regional_manager = $authStorage->read()->parent_regional_manager;
   $this->parent_zonal_manager    = $authStorage->read()->parent_zonal_manager;
   $this->parent_area_manager     = $authStorage->read()->parent_area_manager;
   $this->parent_sale             = $authStorage->read()->parent_sale;
   $this->view->last_login = $logout_details['login_time'];               
 }

 public function indexAction(){

  $this->checklogin();
  $db = $this->db = Zend_Db_Table::getDefaultAdapter();
  $this->view->params = $params = $this->getRequest()->getParams();
  $auth = Zend_Auth::getInstance();
  $authStorage = $auth->getStorage();
  $gmap = new Application_Model_Gmap();
  $this->view->getUserList = $getUserList = $gmap->getUserList($this->Role, $this->id);
  $role = $this->Role;
  $id = $this->id;

  if($params['LoginID'] != ""){
    $cond .= "AND ex.LoginID = '".$params['LoginID']."'";
  }
  if($params['monthFrom'] != ""){
    $cond .= "AND ex.monthFrom = '".$params['monthFrom']."'";
  }
  if($params['monthTo'] != ""){
    $cond .= "AND ex.monthTo = '".$params['monthTo']."'";
  }

  if ($role == 'super_admin') {
    $user_cond .= "";
  }

  if ($role == 'RM') {
    $user_cond .= "and ex.parent_regional_manager = '" . $id . "' ";
  }

  if ($role == 'ZM') {
    $user_cond .= "and ex.parent_zonal_manager = '" . $id . "' ";
  }

  if ($role == 'ASM') {
    $user_cond .= "and ex.parent_area_manager = '" . $id . "' ";
  }

  if ($role == 'Sales') {
    $user_cond .= "and ex.parent_sale_person = '" . $id . "' ";
  }
  $search_query = "SELECT ex.*, lu.id as staff_id, lu.StaffName, lu.LoginID FROM tbl_expenses as ex left join logi_user as lu on (lu.LoginID = ex.LoginID) WHERE 1 $cond $user_cond order by ex.expense_id desc";
  $this->view->search_result = $search_result = $db->fetchAll($search_query);

  $page=$this->_getParam('page',1);
  $paginator = Zend_Paginator::factory($search_result);      
             $paginator->setCurrentPageNumber($this->getRequest()->getParam('page')); // page number
             $paginator->setItemCountPerPage(30); // number of items to show per page
             $this->view->paginator = $paginator;
             $this->view->totalrec = $paginator->getTotalItemCount();

             if($params['expense'] == 'Generate'){

              $data = array(array('Sr. No.'=> "", 'Login ID'=> "", 'Invoice Type'=> "", 'Date From'=> "", 'Date To'=> "", 'Amount'=> "", 'Remark'=> ""));
              $i = 2; 
              $link = "http://parasmilk.cropnet.co.in/expense/index/uploads/expenses/";
              foreach ($search_result as $rs) {

               $date_from = $rs['dateFrom'];
               $date_to   = $rs['dateTo'];


               $row = array();
               $row[] = stripslashes($i-1);
               $row[] = stripslashes($rs["StaffName"]);
               $row[] = stripslashes($rs["invoiceType"]);
               $row[] = stripslashes($date_from);
               $row[] = stripslashes($date_to);
               $row[] = stripslashes($rs["amount"]);
               $row[] = stripslashes($rs["remark"]);


               $data[] = $row;
               $i++;
             }
             function filterData(&$str){
              $str = preg_replace("/\t/", "\\t", $str);
              $str = preg_replace("/\r?\n/", "\\n", $str);
              if(strstr($str, '"')) $str = '"' . str_replace('"', '""', $str) . '"';
            }

                // file name for download
            $fileName = "expense_report.xls"; 

                // headers for download
            header("Content-Disposition: attachment; filename=\"$fileName\"");
            header("Content-Type: application/vnd.ms-excel");

            $flag = false;
            foreach($data as $row) {
              if(!$flag) {
                        // display column names as first row
                echo implode("\t", array_keys($row)) . "\n";
                $flag = true;
              }
                    // filter data
              array_walk($row, 'filterData');
              echo implode("\t", array_values($row)) . "\n";
            }
            exit;
          }
        }

        public function remarkViewAction()
        {
          $this->checklogin();
          $db = $this->db = Zend_Db_Table::getDefaultAdapter();
          $this->view->params = $params = $this->getRequest()->getParams();
          $query = "SELECT ex.*, lu.StaffName, lu.LoginID FROM tbl_expenses as ex left join logi_user as lu on (lu.LoginID = ex.LoginID) WHERE expense_id =".$params['id'];
          $result = $db->fetchRow($query);
          $this->view->remark = $result;
          $layout = $this->_helper->layout()->disableLayout(''); 
        }

        public function approvedExpenseAction(){
          $response = array();
          $db = $this->db = Zend_Db_Table::getDefaultAdapter();      
          $params = $this->getRequest()->getParams(); 
          if($this->getRequest()->isPost()){
            try{
              $dataArray = array();  
              $dataArray['status'] = 1;
              $db->update('tbl_expenses', $dataArray, array('expense_id=?'=>$params['id']));     
              $response['flag'] = true;
              $response['message'] = "Approved successfully";
            }catch(Exception $e){
              $response['flag'] = false;
              $response['message'] = $e->getMessage();
            }
          }else{
            $response['flag'] = false;
            $response['flag'] = "Method not allowed";
          }
          $response['params'] = $params;
          echo json_encode($response);
          exit;
        }

        public function declineExpenseAction(){

            // echo "approvedLeaveAction";exit;
          $db = $this->db = Zend_Db_Table::getDefaultAdapter();      
          $this->view->params = $params = $this->getRequest()->getParams('id'); 
            // print_r($params);exit; 
            // if($this->getRequest()->isPost()){
          $data = array();  
          $data['status'] = '2';
          $data['remark']               = $params['remark'];
          $data['approval_remark']      = $params['remark'];
          $db->update('tbl_expenses', $data, array('expense_id=?'=>$params['id']));     
          $this->view->successMessage = "Approved successfully.";               
          $this->_redirect('/expense');
            // }

        }

        public function checklogin(){   
          $auth = Zend_Auth::getInstance(); 
          $errorMessage = ""; 
          /*************** check user identity ************/
          if(!$auth->hasIdentity()){
            $this->_redirect('admin/index');  
          }   
        }     
      }