<?php

/**
 * Logimetrix Techsolution Pvt. Ltd.
 * File Name   : NotificationController.php
 * Created By : Ajay Kumar
 * Created Date: 22 July 2018
 */

class NotificationController extends Zend_Controller_Action{
	var $dbAdapter;

	public function init(){
		/* Initialize action controller here */
		$bootstrap                     = $this->getInvokeArg('bootstrap');
		$aConfig                       = $bootstrap->getOptions();
		$this->view->siteurl           = $aConfig['site']['image']['url'];
		$this->dbAdapter               = Zend_Db_Table::getDefaultAdapter();
		$auth                          = Zend_Auth::getInstance();
		$authStorage                   = $auth->getStorage();
		$users                         = new Application_Model_Users();
		$logout_details                = $users->getUserLoginDetailByWebLoginCode($this->WebLoginID);
		$this->view->last_login        = $logout_details['login_time'];
		$this->currdate                = date("Y-m-d H:i:s", strtotime('+330 minutes'));
		$this->WebLoginID              = $authStorage->read()->WebLoginID;
		$this->Role                    = $authStorage->read()->Role;
		$this->id                      = $authStorage->read()->id;
		$this->parent_regional_manager = $authStorage->read()->parent_regional_manager;
		$this->parent_zonal_manager    = $authStorage->read()->parent_zonal_manager;
		$this->parent_area_manager     = $authStorage->read()->parent_area_manager;
		$this->parent_sale             = $authStorage->read()->parent_sale;
		$this->view->last_login        = $logout_details['login_time'];
	}


    /**
     * index() method is used to send notification
     * @return True 
     */
    public function indexAction(){
    	$this->checklogin();
    	$this->db              = Zend_Db_Table::getDefaultAdapter();
    	$db                    = $this->db;
    	$auth                  = Zend_Auth::getInstance();
    	$authStorage           = $auth->getStorage();
    	$params                = $this->view->params = $this->getRequest()->getParams();
    	$this->role            = $authStorage->read()->Role;
    	$this->view->user_role = $this->role;
    	$id                    = $authStorage->read()->id;
    	$order                 = new Application_Model_Order();
    	$this->view->state     = $state  = $order->getState($this->role, $id);
    	if ($this->getRequest()->isPost()) {
    		if($params['users_id'] == 0){
    			$user_list = $params['user'];
    		}else{
    			$user_list = $params['users'];
    		}

    		foreach ($user_list as $value) {
    			$this->pushNotification($params['message'], $value);
    		}

    		$this->view->successMessage = "Notification has been successfully sent.";
    	}
    }

    function pushNotification($message, $user_id){
       #API access key from Google API's Console
    	define( 'API_ACCESS_KEY', 'AAAA5F1syzg:APA91bE1zLVa56rlaeReQCsAErgp93YfMcLxNb37KqmkHNnjcNqXukqCAq32DmdyxaNlDTHuEBctjz9md-Rz0TkgnQtiMSMi4obYjLFSsXcu5P7Q8U2_C5vALlQUzkwLs8g91xuD7lVw' );


    	$sql_get_fire_base_key = "select fire_base_id from logi_user where id = '".$user_id."'";
    	$fire_base_result = $this->db->fetchRow($sql_get_fire_base_key);
        if($fire_base_result['fire_base_id'] !=  "" ){
            $registrationIds    = $fire_base_result['fire_base_id'];
            $body               = $message;
            $title = 'Rufil';
            $msg = array
            (
                'body'  => $body,
                'title' => $title,
                'icon'  => 'myicon',/*Default Icon*/
                'sound' => 'mySound'/*Default sound*/
            );
            $fields = array
            (
                'to'        => $registrationIds,
                'notification'  => $msg
            );


            $headers = array
            (
                'Authorization: key=' . API_ACCESS_KEY,
                'Content-Type: application/json'
            );
          #Send Reponse To FireBase Server    
            $ch = curl_init();
            curl_setopt( $ch,CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send' );
            curl_setopt( $ch,CURLOPT_POST, true );
            curl_setopt( $ch,CURLOPT_HTTPHEADER, $headers );
            curl_setopt( $ch,CURLOPT_RETURNTRANSFER, true );
            curl_setopt( $ch,CURLOPT_SSL_VERIFYPEER, false );
            curl_setopt( $ch,CURLOPT_POSTFIELDS, json_encode( $fields ) );
            $result = curl_exec($ch );

            curl_close( $ch );
          #Echo Result Of FireBase Server
            return $result;
        }
        
    }

    /*** getDistrictByStateIdAction function are used to get district list by state id**/
    public function getDistrictAction(){
    	$this->checklogin();
    	$db                   = $this->db;
    	$this->view->params   = $params = $this->getRequest()->getParams();
    	$order                = new Application_Model_Order();
    	if($params['type'] == 'district'){
    		$this->view->district = $district = $order->getDistrictList($params['stateId']);
    	}else{
    		$this->view->user_list = $user_list = $order->getUserList($params['state_id'], $params['district_id'], $params['role_id']);
    	}
    	$this->_helper->layout()->disableLayout(); 
    }

    public function checklogin()
    {
    	$auth         = Zend_Auth::getInstance();
    	$errorMessage = "";
    	/*************** check user identity ************/
    	if (!$auth->hasIdentity()) {
    		$this->_redirect('/admin');
    	}
    }
}